;***********************************************************************
w       equ     0               ;parametr instrukci
f       equ     1               ;parametr instrukci
f0      equ     0x00
tmr0    equ     0x01
optreg  equ     0x01            ;pouzijeme prime adresovani
pcl     equ     0x02
status  equ     0x03            ;status je na adrese 0x03
fsr     equ     0x04
porta   equ     0x05
trisa   equ     0x05            ;pouzijeme prime adresovani
portb   equ     0x06
trisb   equ     0x06            ;pouzijeme prime adresovani
intcon  equ     0x0B
c_disp  equ     0x0C            ;citac multiplexeru
disp1   equ     0x0D            ;pamet pro 1 sedmisegmentovku
disp3   equ     0x0E            ;pamet pro 2 sedmisegmentovku
disp2   equ     0x0F            ;pamet pro 3 sedmisegmentovku
disp4   equ     0x10            ;pamet pro 4 sedmisegmentovku
sec     equ     0x11            ;citac 1 sekundy
;***********************************************************************
#define RP0     status,5
#define T0IF    intcon,2        ;indikace preteceni tmr0
#define C       status,0
;***********************************************************************
	list    p = 16f84
	__config 0x3ff1         ;nastaveni konfigurace
;***********************************************************************
	org     0x0000
	goto    Main
;***********************************************************************
Tab1    addwf   pcl,f           ;pricte W k citaci instrukci
	retlw   B'11000000'     ; zobrazi 0
	retlw   B'11111001'     ; zobrazi 1
	retlw   B'10100100'     ; zobrazi 2
	retlw   B'10110000'     ; zobrazi 3
	retlw   B'10011001'     ; zobrazi 4
	retlw   B'10010010'     ; zobrazi 5
	retlw   B'10000010'     ; zobrazi 6
	retlw   B'11111000'     ; zobrazi 7
	retlw   B'10000000'     ; zobrazi 8
	retlw   B'10010000'     ; zobrazi 9
;***********************************************************************
Tab2    addwf   pcl,f           ;pricte W k citaci instrukci
	retlw   B'11111110'     ;anoda 1. sedmisegmentovky
	retlw   B'11111011'     ;anoda 3. sedmisegmentovky
	retlw   B'11111101'     ;anoda 2. sedmisegmentovky
	retlw   B'11110111'     ;anoda 4. sedmisegmentovky
;***********************************************************************
Counter clrf    sec             ;vynuluje registr sec
	incf    disp1,f         ;pricte 1 k registru Disp1
	movlw   0x0A 
	subwf   disp1,w         ;odecte od Disp1 desitku a ulozi do W
	btfss   C               ;je-li C=1, Disp1 pretekl pres 9
	goto    Count_A
	clrf    disp1
	incf    disp2,f         ;pricte 1 k registru Disp2
	movlw   0x0A 
	subwf   disp2,w         ;odecte od Disp2 desitku a ulozi do W
	btfss   C               ;je-li C=1, Disp2 pretekl pes 9
	goto    Count_A
	clrf    disp2
	incf    disp3,f         ;pricte 1 k registru Disp3
	movlw   0x0A 
	subwf   disp3,w         ;odecte od Disp3 desitku a ulozi do W
	btfss   C               ;je-li C=1, Disp3 pretekl pes 9
	goto    Count_A
	clrf    disp3
	incf    disp4,f         ;pricte 1 k registru Disp4
	movlw   0x0A 
	subwf   disp4,w         ;odecte od Disp4 desitku a ulozi do W
	btfss   C               ;je-li C=1, Disp4 pretekl pres 9
	goto    Count_A
	clrf    disp4
Count_A return
;***********************************************************************
Displej incf    c_disp,f        ;pricte 1 k citaci multiplexeru
	movlw   0x04
	subwf   c_disp,w
	btfsc   C               ;je-li C=1, c_disp pretekl pes 3
	clrf    c_disp          ;pretekl-li c_disp, vynulujeme ho
	movlw   0xFF 
	movwf   porta           ;zhasneme displej
	movlw   disp1 
	movwf   fsr             ;neprima adresa disp1
	movf    c_disp,w        ;c_disp prekopirujeme do W
	addwf   fsr,f           ;pricteme c_disp k neprime adrese disp1
				;vybereme tak jeden z registr disp1-4
	movf    f0,w            ;vybrany registr disp do registru W
	call    Tab1            ;zakodujeme obsah registru na znak
	movwf   portb           ;posleme znak na port B
	movf    c_disp,w 
	call    Tab2            ;vybereme prislusnou anodu displeje
	movwf   porta           ;sepneme prislusny tranzistor
	return
;***********************************************************************
Main    bsf     RP0             ;stranka 1 pameti RAM
	movlw   B'11010011'
	movwf   optreg          ;konfigurace TMR0 a preddelicky
	movlw   0x00 
	movwf   portb           ;port B je vystupni
	movlw   0xF0
	movwf   porta           ;bity 0-3 portu A jsou vystupni
	bcf     RP0             ;stranka 0 pameti RAM
	movlw   0xFF 
	movwf   porta           ;zhasne vsechny sedmisegmentovky
	clrf    disp1           ;vynuluje registr Disp1
	clrf    disp2           ;vynuluje registr Disp2
	clrf    disp3           ;vynuluje registr Disp3
	clrf    disp4           ;vynuluje registr Disp4
	clrf    c_disp          ;vynuluje citac multiplexeru
;***********************************************************************
Main_A  bcf     T0IF            ;vynulovani bitu T0IF
	clrf    tmr0            ;vynulovani TMR0 a preddelicky
Main_B  btfss   T0IF            ;testovani bitu T0IF
	goto    Main_B
	call    Displej         ;podprogram multiplexovani displeje
	incf    sec,f           ;pricte 1 k registru citace sekund
	movlw   0xC7
	subwf   sec,w           ;odecte od sec 199 a ulozi do W
	btfsc   C               ;je li C=1, registr sec nepretekl
	call    Counter         ;jestlize sec pretekl, zavola Counter
	goto    Main_A          ;skoci na zacatek smycky
	end
